// Code generated by pggen. DO NOT EDIT.

package order

import (
	"context"
	"fmt"
	"github.com/jackc/pgtype"
	"github.com/jackc/pgx/v4"
)

const findOrdersByPriceSQL = `SELECT * FROM orders WHERE order_total > $1;`

type FindOrdersByPriceRow struct {
	OrderID    int32              `json:"order_id"`
	OrderDate  pgtype.Timestamptz `json:"order_date"`
	OrderTotal pgtype.Numeric     `json:"order_total"`
	CustomerID pgtype.Int4        `json:"customer_id"`
}

// FindOrdersByPrice implements Querier.FindOrdersByPrice.
func (q *DBQuerier) FindOrdersByPrice(ctx context.Context, minTotal pgtype.Numeric) ([]FindOrdersByPriceRow, error) {
	rows, err := q.conn.Query(ctx, findOrdersByPriceSQL, minTotal)
	if err != nil {
		return nil, fmt.Errorf("query FindOrdersByPrice: %w", err)
	}
	defer rows.Close()
	items := []FindOrdersByPriceRow{}
	for rows.Next() {
		var item FindOrdersByPriceRow
		if err := rows.Scan(&item.OrderID, &item.OrderDate, &item.OrderTotal, &item.CustomerID); err != nil {
			return nil, fmt.Errorf("scan FindOrdersByPrice row: %w", err)
		}
		items = append(items, item)
	}
	if err := rows.Err(); err != nil {
		return nil, fmt.Errorf("close FindOrdersByPrice rows: %w", err)
	}
	return items, err
}

// FindOrdersByPriceBatch implements Querier.FindOrdersByPriceBatch.
func (q *DBQuerier) FindOrdersByPriceBatch(batch *pgx.Batch, minTotal pgtype.Numeric) {
	batch.Queue(findOrdersByPriceSQL, minTotal)
}

// FindOrdersByPriceScan implements Querier.FindOrdersByPriceScan.
func (q *DBQuerier) FindOrdersByPriceScan(results pgx.BatchResults) ([]FindOrdersByPriceRow, error) {
	rows, err := results.Query()
	if err != nil {
		return nil, fmt.Errorf("query FindOrdersByPriceBatch: %w", err)
	}
	defer rows.Close()
	items := []FindOrdersByPriceRow{}
	for rows.Next() {
		var item FindOrdersByPriceRow
		if err := rows.Scan(&item.OrderID, &item.OrderDate, &item.OrderTotal, &item.CustomerID); err != nil {
			return nil, fmt.Errorf("scan FindOrdersByPriceBatch row: %w", err)
		}
		items = append(items, item)
	}
	if err := rows.Err(); err != nil {
		return nil, fmt.Errorf("close FindOrdersByPriceBatch rows: %w", err)
	}
	return items, err
}

const findOrdersMRRSQL = `SELECT date_trunc('month', order_date) AS month, sum(order_total) AS order_mrr
FROM orders
GROUP BY date_trunc('month', order_date);`

type FindOrdersMRRRow struct {
	Month    pgtype.Timestamptz `json:"month"`
	OrderMRR pgtype.Numeric     `json:"order_mrr"`
}

// FindOrdersMRR implements Querier.FindOrdersMRR.
func (q *DBQuerier) FindOrdersMRR(ctx context.Context) ([]FindOrdersMRRRow, error) {
	rows, err := q.conn.Query(ctx, findOrdersMRRSQL)
	if err != nil {
		return nil, fmt.Errorf("query FindOrdersMRR: %w", err)
	}
	defer rows.Close()
	items := []FindOrdersMRRRow{}
	for rows.Next() {
		var item FindOrdersMRRRow
		if err := rows.Scan(&item.Month, &item.OrderMRR); err != nil {
			return nil, fmt.Errorf("scan FindOrdersMRR row: %w", err)
		}
		items = append(items, item)
	}
	if err := rows.Err(); err != nil {
		return nil, fmt.Errorf("close FindOrdersMRR rows: %w", err)
	}
	return items, err
}

// FindOrdersMRRBatch implements Querier.FindOrdersMRRBatch.
func (q *DBQuerier) FindOrdersMRRBatch(batch *pgx.Batch) {
	batch.Queue(findOrdersMRRSQL)
}

// FindOrdersMRRScan implements Querier.FindOrdersMRRScan.
func (q *DBQuerier) FindOrdersMRRScan(results pgx.BatchResults) ([]FindOrdersMRRRow, error) {
	rows, err := results.Query()
	if err != nil {
		return nil, fmt.Errorf("query FindOrdersMRRBatch: %w", err)
	}
	defer rows.Close()
	items := []FindOrdersMRRRow{}
	for rows.Next() {
		var item FindOrdersMRRRow
		if err := rows.Scan(&item.Month, &item.OrderMRR); err != nil {
			return nil, fmt.Errorf("scan FindOrdersMRRBatch row: %w", err)
		}
		items = append(items, item)
	}
	if err := rows.Err(); err != nil {
		return nil, fmt.Errorf("close FindOrdersMRRBatch rows: %w", err)
	}
	return items, err
}
